package de.jg_cody.Teraplex.ui.Flur;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.SharedPreferences;
import android.graphics.BitmapFactory;
import android.graphics.drawable.BitmapDrawable;
import android.os.Build;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;

import androidx.annotation.NonNull;
import androidx.annotation.RequiresApi;
import androidx.fragment.app.Fragment;
import androidx.lifecycle.ViewModelProvider;
import androidx.recyclerview.widget.ItemTouchHelper;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.google.android.material.floatingactionbutton.FloatingActionButton;

import org.jetbrains.annotations.NotNull;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.Base64;
import java.util.Objects;

import de.jg_cody.Teraplex.AddButtonDialogSingle;
import de.jg_cody.Teraplex.AddButtonsDialogDouble;
import de.jg_cody.Teraplex.AddHeadlineDialog;
import de.jg_cody.Teraplex.Cricketer;
import de.jg_cody.Teraplex.MainActivity;
import de.jg_cody.Teraplex.R;
import de.jg_cody.Teraplex.ui.rooms.ListAdapter;
import de.jg_cody.Teraplex.ui.rooms.ListItem;
import de.jg_cody.Teraplex.ui.rooms.ListItemDouble;
import de.jg_cody.Teraplex.ui.rooms.ListItemHeadline;
import de.jg_cody.Teraplex.ui.rooms.ListItemSingle;
import de.jg_cody.Teraplex.ui.rooms.ListItemSpace;

import static android.content.Context.MODE_PRIVATE;

public class FlurFragment extends Fragment implements AddButtonDialogSingle.AddButtonDialogListenerSingle, AddButtonsDialogDouble.AddButtonsDialogListenerDouble, AddHeadlineDialog.AddHeadlineDialogListener {

    private FlurViewModel flurViewModel;

    String[] commands = {"Hello1", "Hello2", "Hello3", "Hello4", "Hello5"};
    int[] type = {0, 1, 0, 0, 1};

    RecyclerView listView;
    ListAdapter listAdapter;
    FloatingActionButton addfab;

    ArrayList<ListItem> items;

    ArrayList<Cricketer> cricketersList = new ArrayList<>();

    String tabname;


    public FlurFragment(String tabname) {
        this.tabname = tabname;
    }

    @RequiresApi(api = Build.VERSION_CODES.O)
    public View onCreateView(@NonNull LayoutInflater inflater,
                             ViewGroup container, Bundle savedInstanceState) {
        flurViewModel =
                new ViewModelProvider(this).get(FlurViewModel.class);
        View root = inflater.inflate(R.layout.fragment_flur, container, false);
        SharedPreferences p = requireContext().getSharedPreferences("appsettings", Activity.MODE_PRIVATE);
        String Background = p.getString("Background", null);
        if (Background != null) {
            ImageView I = root.findViewById(R.id.Background);
            byte[] BA = Base64.getDecoder().decode(Background);
            I.setImageDrawable(new BitmapDrawable(getResources(), MainActivity.scaleCenterCrop(BitmapFactory.decodeByteArray(BA, 0, BA.length), MainActivity.getScreenHeight(), MainActivity.getScreenWidth())));
            I.setScaleType(ImageView.ScaleType.CENTER_CROP);
        }


        listView = root.findViewById(R.id.listView);

        items = new ArrayList<ListItem>();


        listAdapter = new ListAdapter(getContext(), items);
        listView.setLayoutManager(new LinearLayoutManager(getContext()));
        listView.setAdapter(listAdapter);

        ItemTouchHelper h = new ItemTouchHelper(new ItemTouchHelper.Callback() {
            @Override
            public int getMovementFlags(@NonNull @NotNull RecyclerView recyclerView, @NonNull @NotNull RecyclerView.ViewHolder viewHolder) {
                int dragFlags = ItemTouchHelper.UP | ItemTouchHelper.DOWN;
                int swipeFlags = ItemTouchHelper.START | ItemTouchHelper.END;
                return makeMovementFlags(dragFlags, swipeFlags);
            }

            @Override
            public boolean onMove(@NonNull @NotNull RecyclerView recyclerView, @NonNull @NotNull RecyclerView.ViewHolder viewHolder, @NonNull @NotNull RecyclerView.ViewHolder target) {
                //listAdapter.onItemMove(viewHolder.getAdapterPosition(), target.getAdapterPosition());
                listAdapter.swap(viewHolder.getAdapterPosition(), target.getAdapterPosition());
                return true;
            }

            @Override
            public void onSwiped(@NonNull @NotNull RecyclerView.ViewHolder viewHolder, int direction) {
                listAdapter.remove(viewHolder.getAdapterPosition());
            }

            @Override
            public boolean isLongPressDragEnabled() {
                return true;
            }

            @Override
            public boolean isItemViewSwipeEnabled() {
                return true;

            }
        });
        h.attachToRecyclerView(listView);

        addfab = root.findViewById(R.id.fab);
        if (MainActivity.editmode) {
            addfab.setVisibility(View.VISIBLE);
        } else {
            addfab.setVisibility(View.GONE);
        }
        addfab.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                showChooseElement();
            }
        });
        try {
            load();
        } catch (JSONException e) {
            e.printStackTrace();
        }

        return root;
    }

    private void showChooseElement() {
        final String[] listItems = {"SINGLE BUTTON", "DOUBLE BUTTON", "ÜBERSCHRIFT", "PLATZHALTER"};
        AlertDialog.Builder mBuilder = new AlertDialog.Builder(getActivity());
        mBuilder.setTitle("CHOOSE ELEMENT");
        mBuilder.setSingleChoiceItems(listItems, -1, new DialogInterface.OnClickListener() {
            @RequiresApi(api = Build.VERSION_CODES.KITKAT)
            @Override
            public void onClick(DialogInterface dialogInterface, int i) {
                if (i == 0) {
                    openDialog1();
                } else if (i == 1) {
                    openDialog2();
                } else if (i == 2) {
                    openDialog3();
                } else if (i == 3) {
                    listAdapter.add(new ListItemSpace());
                    try {
                        save();
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }

                }

                dialogInterface.dismiss();
            }
        });
        AlertDialog mDialog = mBuilder.create();
        Objects.requireNonNull(mDialog.getWindow()).setBackgroundDrawableResource(R.drawable.button_round);
        mDialog.show();
    }

    public void openDialog1() {
        AddButtonDialogSingle addButtonDialogSingle = new AddButtonDialogSingle();
        addButtonDialogSingle.setFragment(this);
        addButtonDialogSingle.show(getActivity().getSupportFragmentManager(), "example dialog");

    }

    public void openDialog2() {
        AddButtonsDialogDouble addButtonsDialogDouble = new AddButtonsDialogDouble();
        addButtonsDialogDouble.setFragment(this);
        addButtonsDialogDouble.show(getActivity().getSupportFragmentManager(), "example dialog");
    }

    public void openDialog3() {
        AddHeadlineDialog addHeadlineDialog = new AddHeadlineDialog();
        addHeadlineDialog.setFragment(this);
        addHeadlineDialog.show(getActivity().getSupportFragmentManager(), "Headline");
    }

    @RequiresApi(api = Build.VERSION_CODES.KITKAT)
    @Override
    public void applyTextsSingle(String name, String command, String button) {
        //items.add(new ListItemSingle(0,name,command,button));
        listAdapter.add(new ListItemSingle(name, command, button));
        try {
            save();
        } catch (JSONException e) {
            e.printStackTrace();
        }

    }

    @RequiresApi(api = Build.VERSION_CODES.KITKAT)
    @Override
    public void applyTextsDouble(String name, String command1, String command2, String button1, String button2) {
        listAdapter.add(new ListItemDouble(name, command1, command2, button1, button2));
        try {
            save();
        } catch (JSONException e) {
            e.printStackTrace();
        }
    }

    @RequiresApi(api = Build.VERSION_CODES.KITKAT)
    @Override
    public void applyTextsHeadline(String headline) {
        listAdapter.add(new ListItemHeadline(headline));
        try {
            save();
        } catch (JSONException e) {
            e.printStackTrace();
        }


    }

    public void load() throws JSONException {
        if (MainActivity.editmode) {
            addfab.setVisibility(View.VISIBLE);
        } else {
            addfab.setVisibility(View.GONE);
        }
        listAdapter.clear();
        SharedPreferences p = requireContext().getSharedPreferences("appsettings", Activity.MODE_PRIVATE);
        String listItems = p.getString("listItems." + tabname, "[]");
        JSONArray listItems2 = new JSONArray(listItems);
        for (int i = 0; i < listItems2.length(); i++) {
            JSONObject item = listItems2.getJSONObject(i);
            listAdapter.add(ListItem.fromJson(item));
        }
        ;
    }

    @RequiresApi(api = Build.VERSION_CODES.KITKAT)
    public void save() throws JSONException {
        JSONArray listItems2 = new JSONArray();
        for (ListItem Item : listAdapter.getObjects()) {
            listItems2.put(Item.toJson());
        }
        SharedPreferences.Editor editor = requireContext().getSharedPreferences("appsettings", MODE_PRIVATE).edit();
        editor.putString("listItems." + tabname, listItems2.toString());
        editor.apply();
    }
}
